MoreText Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | Friends | List of all members
MoreText Class Reference

the main class to read the text part of More Text file More...

`#include <MoreText.hxx>`

## Public Member Functions
| MoreText (MoreParser &parser)
| constructor More...
virtual | ~MoreText ()
| destructor More...
int | version () const
| returns the file version More...
int | numPages () const
| returns the number of pages More...

## Protected Member Functions
bool | createZones ()
| try to create the text zones using read data More...
bool | sendMainText ()
| send a main zone More...
std::shared_ptr< MWAWSubDocument > | getHeaderFooter (bool header)
| returns a subdocument to send the header or the footer More...
bool | readTopic (MWAWEntry const &entry)
| read the list of topic positions More...
int | getLastTopicChildId (int tId) const
| returns the last sub topic id corresponding to a topic and its child More...
int | checkTopicList (size_t tId, std::set< size_t > &parent)
| check that the topic and its child does not loop (if so, cut some edge), return the number of breakpages in the sublist More...
bool | readComment (MWAWEntry const &entry)
| read the list of comment/header/footer zones More...
bool | readSpeakerNote (MWAWEntry const &entry)
| read the list of speaker note More...
bool | sendText (MWAWEntry const &entry, MWAWFont const &font)
| send a text entry More...
bool | sendComment (int cId)
| try to send a comment knowing the comment id More...
bool | sendSpeakerNote (int nId)
| try to send a speakernote knowing the note id More...
bool | sendTopic (int tId, int dLevel, std::vector< MWAWParagraph > &paraStack)
| try to send a topic knowing the topic id More...
bool | readFonts (MWAWEntry const &entry)
| read the list of fonts More...
bool | readOutlineList (MWAWEntry const &entry)
| read the list of outlines More...
bool | readOutline (MWAWEntry const &entry, MoreTextInternal::Outline &outline)
| read a outline More...
bool | readFont (MWAWEntry const &entry, std::string &fName, int &fId)
| try to read a fontname More...
bool | readTabs (MWAWEntry const &entry, MoreTextInternal::Paragraph &para, std::string &mess)
| try to read some tabs More...
bool | readCustomListLevel (MWAWEntry const &entry, MWAWListLevel &level)
| read a custom list level More...
bool | parseUnknown (MWAWEntry const &entry, long fDecal)
| try to read either a font, a fontname, a pattern, a int More...

## Protected Attributes
MWAWParserStatePtr | m_parserState
| the parser state More...
std::shared_ptr< MoreTextInternal::State > | m_state
| the state More...
MoreParser * | m_mainParser
| the main parser; More...

## Private Member Functions
| MoreText (MoreText const &orig)=delete
MoreText & | operator= (MoreText const &orig)=delete

## Friends
class | MoreParser
class | MoreTextInternal::SubDocument

## Detailed Description

the main class to read the text part of More Text file

## Constructor & Destructor Documentation

## ◆ MoreText() [1/2]

MoreText::MoreText | ( | MoreParser & | parser | ) |
| explicit

constructor

## ◆ ~MoreText()

MoreText::~MoreText | ( |  | ) |
| virtual

destructor

## ◆ MoreText() [2/2]

MoreText::MoreText | ( | MoreText const & | orig | ) |
| privatedelete

## Member Function Documentation

## ◆ checkTopicList()

int MoreText::checkTopicList | ( | size_t | tId,
|  | std::set< size_t > & | parent
| ) |  |
| protected

check that the topic and its child does not loop (if so, cut some edge), return the number of breakpages in the sublist

Referenced by checkTopicList(), and createZones().

## ◆ createZones()

bool MoreText::createZones | ( |  | ) |
| protected

try to create the text zones using read data

Referenced by numPages().

## ◆ getHeaderFooter()

std::shared_ptr< MWAWSubDocument > MoreText::getHeaderFooter | ( | bool | header | ) |
| protected

returns a subdocument to send the header or the footer

## ◆ getLastTopicChildId()

int MoreText::getLastTopicChildId | ( | int | tId | ) | const
| protected

returns the last sub topic id corresponding to a topic and its child

Referenced by checkTopicList(), and sendTopic().

## ◆ numPages()

int MoreText::numPages | ( |  | ) | const

returns the number of pages

## ◆ operator=()

MoreText & MoreText::operator= | ( | MoreText const & | orig | ) |
| privatedelete

## ◆ parseUnknown()

bool MoreText::parseUnknown | ( | MWAWEntry const & | entry,
|  | long | fDecal
| ) |  |
| protected

try to read either a font, a fontname, a pattern, a int

Referenced by readOutline().

## ◆ readComment()

bool MoreText::readComment | ( | MWAWEntry const & | entry | ) |
| protected

read the list of comment/header/footer zones

## ◆ readCustomListLevel()

bool MoreText::readCustomListLevel | ( | MWAWEntry const & | entry,
|  | MWAWListLevel & | level
| ) |  |
| protected

read a custom list level

Referenced by readOutline().

## ◆ readFont()

bool MoreText::readFont | ( | MWAWEntry const & | entry,
|  | std::string & | fName,
|  | int & | fId
| ) |  |
| protected

try to read a fontname

Note
  : fId is set to -1 is the field contains only a fontname and can not find the associated id

Referenced by parseUnknown(), and readOutline().

## ◆ readFonts()

bool MoreText::readFonts | ( | MWAWEntry const & | entry | ) |
| protected

read the list of fonts

## ◆ readOutline()

bool MoreText::readOutline | ( | MWAWEntry const & | entry,
|  | MoreTextInternal::Outline & | outline
| ) |  |
| protected

read a outline

Referenced by readOutlineList().

## ◆ readOutlineList()

bool MoreText::readOutlineList | ( | MWAWEntry const & | entry | ) |
| protected

read the list of outlines

## ◆ readSpeakerNote()

bool MoreText::readSpeakerNote | ( | MWAWEntry const & | entry | ) |
| protected

read the list of speaker note

## ◆ readTabs()

bool MoreText::readTabs | ( | MWAWEntry const & | entry,
|  | MoreTextInternal::Paragraph & | para,
|  | std::string & | mess
| ) |  |
| protected

try to read some tabs

Referenced by parseUnknown(), and readOutline().

## ◆ readTopic()

bool MoreText::readTopic | ( | MWAWEntry const & | entry | ) |
| protected

read the list of topic positions

## ◆ sendComment()

bool MoreText::sendComment | ( | int | cId | ) |
| protected

try to send a comment knowing the comment id

Referenced by MoreTextInternal::SubDocument::parse().

## ◆ sendMainText()

bool MoreText::sendMainText | ( |  | ) |
| protected

send a main zone

## ◆ sendSpeakerNote()

bool MoreText::sendSpeakerNote | ( | int | nId | ) |
| protected

try to send a speakernote knowing the note id

Referenced by MoreTextInternal::SubDocument::parse().

## ◆ sendText()

bool MoreText::sendText | ( | MWAWEntry const & | entry,
|  | MWAWFont const & | font
| ) |  |
| protected

send a text entry

Referenced by sendComment(), sendSpeakerNote(), and sendTopic().

## ◆ sendTopic()

bool MoreText::sendTopic | ( | int | tId,
|  | int | dLevel,
|  | std::vector< MWAWParagraph > & | paraStack
| ) |  |
| protected

try to send a topic knowing the topic id

Referenced by MoreTextInternal::SubDocument::parse(), sendMainText(), and sendTopic().

## ◆ version()

int MoreText::version | ( |  | ) | const

returns the file version

Referenced by readOutline().

## Friends And Related Function Documentation

## ◆ MoreParser

friend class MoreParser
| friend

## ◆ MoreTextInternal::SubDocument

friend class MoreTextInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_mainParser

MoreParser* MoreText::m_mainParser
| protected

the main parser;

Referenced by parseUnknown(), readComment(), readOutlineList(), readSpeakerNote(), readTopic(), and sendTopic().

## ◆ m_parserState

MWAWParserStatePtr MoreText::m_parserState
| protected

the parser state

Referenced by getHeaderFooter(), parseUnknown(), readComment(), readCustomListLevel(), readFont(), readFonts(), readOutline(), readOutlineList(), readSpeakerNote(), readTabs(), readTopic(), sendComment(), sendMainText(), sendSpeakerNote(), sendText(), sendTopic(), and version().

## ◆ m_state

std::shared_ptr<MoreTextInternal::State> MoreText::m_state
| protected

the state

Referenced by checkTopicList(), createZones(), getHeaderFooter(), getLastTopicChildId(), numPages(), readComment(), readOutlineList(), readSpeakerNote(), readTopic(), sendComment(), sendMainText(), sendSpeakerNote(), sendTopic(), and version().

The documentation for this class was generated from the following files:

- MoreText.hxx
- MoreText.cxx